#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Cut and Paste in Place
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>CorG Tool>Cut and Paste in Place
#		 Note:	Selection, which must be inside a component or group, is re"MoveMe"d from component or group.
#    Date:	Sep 2015
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Cut and Paste in Place") { SDM::Cut_and_Paste_in_Place.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Cut_and_Paste_in_Place

		def self.main
			mod = Sketchup.active_model
			ent = mod.entities
			sel = mod.selection
			unless sel.empty?
				mod.start_operation "Cut and Paste in Place"
				kid = sel[0]; mom = kid.parent;
				unless mom==mod
					mod.definitions.purge_unused
					container = mom.name;
					grp = ent.add_group sel
					cmp = grp.to_component
					cmp.definition.name = "MoveMe"
					@rmv = false;
					ent.grep(Sketchup::ComponentInstance).each{|ci|
						e=ci.definition.entities;t=ci.transformation;
						self.recurse(e,t)
					}
					unless @rmv
						ent.grep(Sketchup::Group).each{|g|
							e=g.entities;t=g.transformation
							self.recurse(e,t)
						}
					end
					if @rmv
						mod.definitions[container].entities.grep(Sketchup::ComponentInstance).each{|c|
							if c.definition.name == "MoveMe"
								c.erase!
							end
						}
					end
					mod.definitions.purge_unused
					mod.active_layer='Layer0'
				else
					cmps = sel.grep(Sketchup::ComponentInstance)
					cmps.each_with_index{|ci,n|
						if n==0
							ci.make_unique
							# ci.definition.name='SRX'+Time.now.usec.to_s
						else
							ci.definition=cmps[0].definition
						end
					}
				end
				mod.commit_operation
			else
				UI.messagebox "Nothing Selected"
			end
		end
		
		def self.recurse(ents,tran)
			ents.grep(Sketchup::ComponentInstance).each{|ci|
				if ci.definition.name=="MoveMe"
					org=ci.transformation.origin.transform(tran);
					trn=ci.transformation.to_a; trn[12]=org.x;trn[13]=org.y;trn[14]=org.z
					new=Sketchup.active_model.entities.add_instance(ci.definition,trn)
					new.explode; @rmv=true
				else
					e=ci.definition.entities; t=tran*ci.transformation; 
					self.recurse(e,t)
				end
			}
			ents.grep(Sketchup::Group).each{|g|
				e=g.entities; t=tran*g.transformation
				self.recurse(e,t)
			}
		end
		
	end
end
